#include "common.h"
#define SIZE 4096
#define COUNT 1000

int bfds[COUNT];
char *bufs[COUNT];

static void check_line(int id, int last) {
	for (int i = 0; i < 0x40; i++)
		for (int j = 0; j < 0x40; j++) {
		const char expected = (i == j && i <= last) ? 0xaa : 0x00;
			if (bufs[id][i * 0x40 + j] != expected) {
				fprintf(stderr, "Invalid value at (%d, %d)\n", i, j);
				exit(-1);
			}
		}
}

int main() {
	int fd = do_open0();

	for (int i = 0; i < COUNT; i++) {
		bfds[i] = do_create_buf(fd, SIZE, 0x40);
		bufs[i] = (char *) mmap(0, SIZE, PROT_READ | PROT_WRITE, MAP_SHARED, bfds[i], 0);
		if (bufs[i] == MAP_FAILED)
			syserr("mmap");
	}


	uint32_t *cmd = (uint32_t*) bufs[0];
	cmd[0] = FHARDDOOM_USER_DRAW_LINE_HEADER(0, 0xaa);
	cmd[1] = FHARDDOOM_USER_DRAW_LINE_W1(0, 0);

	for (int i = 1; i < COUNT; i++) {
		const int last = 1 + i % 0x20;
		cmd[2] = FHARDDOOM_USER_DRAW_LINE_W2(last, last);
		do_run(fd, bfds[0], 0, sizeof(uint32_t) * 3, 1, &bfds[i]);
		do_wait(fd, 0);
		check_line(i, last);
	}

	for (int i = 0; i < COUNT; i++) {
		do_munmap(bufs[i], SIZE);
		do_close(bfds[i]);
	}

	do_close(fd);
	return 0;
}
